Option Explicit On 
Option Strict Off

Module ExFormat

    Sub Main()
        Dim n As Byte

        Time = GetTickCount()

        ZeroMemory(PassTbl, 16 * PASS_NO, 0)

        ' sprawdzenie wersji biblioteki
        Console.WriteLine("")
        Console.WriteLine("Odczyt wersji biblioteki")
        TVTT_GetVersion(Ver, SubVer, APIVer)
        Console.WriteLine("Wersja pliku:" & vbTab & vbTab & vbTab & vbTab & Ver & "." & SubVer)
        Console.WriteLine("Wersja API:" & vbTab & vbTab & vbTab & APIVer)

        ' otwarcie dostepu do tokenu
        Console.Write("Otwarcie dostepu do Tokenu:")
        TokenInfoTblSize = TVTTTI_TABLE_SIZE                        ' wpisanie rozmiaru tablicy
        Status = TVTT_FindToken(TokenH, 10, TOKEN_ID, 0, 0, TokenInfoTblSize, TokenInfoTbl(0))
        If (Status <> 0) Then
            Console.WriteLine(vbTab + IntToHex((Status \ 8), 2) & ":" & IntToHex((Status And &HFF), 2))
        Else
            Console.WriteLine(vbTab & "OK")
        End If

        n = 0
        While (n < TokenInfoTblSize)
            If (TokenInfoOffsetTbl(n) = TVTTTI_ID) Then
                Console.WriteLine(vbTab & vbTab & vbTab & vbTab & TokenInfoTextTbl(n) & IntToHex(TokenInfoTbl(TokenInfoOffsetTbl(n)), 8))
            Else
                Console.WriteLine(vbTab & vbTab & vbTab & vbTab & TokenInfoTextTbl(n) & TokenInfoTbl(TokenInfoOffsetTbl(n)))
            End If
            n = n + 1
        End While

        ' rozpoczecie sesji
        Console.Write("Rozpoczecie sesji:")
        Status = TVTT_StartSession(TokenH, 1)
        If (Status <> 0) Then
            Console.WriteLine(vbTab & vbTab & IntToHex(Status \ 8, 2) + ":" + IntToHex(Status And &HFF, 2))
        Else
            Console.WriteLine(vbTab & vbTab & "OK")
        End If

        ' format Tokenu
        Console.Write("FormatTokenu:")
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutKey = 0                                                  ' znacznik wiadomosci nie szyfrowanej
        OutDataB(TVTTD_CMD) = TVTTC_FORMAT                          ' rozkaz formatowania Tokenu
        OutDataB(TVTTD_PARAM1) = 1                                  ' najmodszy bajt ID odbiorcy Tokenu

        'haso formatowania
        OutDataA(4) = TOKEN_FORMAT_PASS And &HFF
        OutDataA(3) = (TOKEN_FORMAT_PASS \ &H100) And &HFF
        OutDataA(2) = (TOKEN_FORMAT_PASS \ &H10000) And &HFF
        OutDataA(1) = (TOKEN_FORMAT_PASS \ &H1000000) And &HFF
        OutDataA(0) = (TOKEN_FORMAT_PASS \ &H100000000) And &HFF
        'numer seryjny
        OutDataA(5) = 5
        OutDataA(6) = 6
        OutDataA(7) = 7
        OutDataA(8) = 8

        TVTT_CalcAuth(OutDataA, OutDataB)      ' policzenie bloku kontrolnego
        Status = TVTT_Talk(TokenH, 200, OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        If (Status = &H600) Then
            Console.WriteLine(vbTab & vbTab & vbTab & "Restart Tokenu...")
        Else
            Console.WriteLine(vbTab & vbTab & vbTab & IntToHex((Status \ 8), 2) + ":" + IntToHex(Status And &HFF, 2))
        End If

        ' zakonczenie sesji
        Console.WriteLine("Zamkniecie sesji:")
        Status = TVTT_EndSession(TokenH)
        If (Status <> 0) Then
            Console.WriteLine(vbTab & vbTab & IntToHex((Status \ 8), 2) & ":" & IntToHex(Status And &HFF, 2))
        Else
            Console.WriteLine(vbTab & vbTab & "OK")
        End If

        ' zamknicie dostpu do Tokenu
        Console.Write("Zamkniecie dostepu do Tokenu:")
        Status = TVTT_FreeToken(TokenH)
        If (Status <> 0) Then
            Console.WriteLine(vbTab & IntToHex((Status \ 8), 2) & ":" & IntToHex(Status And &HFF, 2))
        Else
            Console.WriteLine(vbTab & "OK")
        End If

        Time = GetTickCount() - Time
        Console.WriteLine("Time " & Int(Time / 1000) & "." & Int(Time / 10) Mod 100)

    End Sub

End Module
