Module ExNVMemDecryptWrite

    Sub Main()
        Dim n, i, c As Long
        Dim tmp As Byte
        Dim stmp As String
        Dim iv(16) As Byte
        Dim data() As Byte
        Dim mem As Long
        Dim pdata As Long

        ZeroMemory(PassTbl, 16 * PASS_NO, 0)

        n = 0
        While n < PASS_NO
            stmp = "Pass" & n
            For tmp = 0 To Len(stmp) - 1
                PassTbl(n * 16 + tmp) = Asc(Mid(stmp, tmp + 1, 1))
            Next
            n = n + 1
        End While

        StartProlog()


        ' Przykad obrazujcy zapis zaszyfrowanych danych do TeleTokenu. Zademonstrowane jest
        ' uycie trybu CBC do zaszyfrowania (przygotowania) danych do zapisu do TeleTokenu.
        ' Z drugiej strony TeleToken podczas operacji zapisu rozszyfrowywuje dane rwnie
        ' w trybie CBC, z uyciem wbudowanej pamici ulotnej (1 sektora). }

        ' zainicjowanie OutKey
        OutKey = (GetTickCount() And &HFFFFFF00) Or &HF00


        ' wylosowanie init vector-a
        TVTT_Rand(iv, 0)

        mem = TokenInfoTbl(TVTTTI_NV_MEM_SIZE) * 16
        ReDim data(mem)

        ' przygotowanie danych do zapisania
        For n = 0 To mem - 1
            data(n) = n Mod 256
        Next

        ' szyfrowanie metoda CBC

        ' XOR 1 bloku danych z init vector-em
        For n = 0 To 15
            data(n) = data(n) Xor iv(n)
        Next


        ' petla szyfrujca
        n = TokenInfoTbl(TVTTTI_NV_MEM_SIZE)
        pdata = 0

        While True


            rijndaelEncrypt(PassTbl, 0, data, pdata)

            n = n - 1
            If n = 0 Then Exit While

            pdata = pdata + 16

            ' XOR bloku n z zaszyfrowanym blokiem n-1
            For c = 0 To 15
                data(pdata + c) = data(pdata + c) Xor data(pdata - 16 + c)
            Next

        End While

        ' Przygotowanie sektora pamici ulotnej do deszyfrowania w trybie CBC. Do sektora "0"
        ' wgrywany jest "init vector", z ktrym TeleToken automatycznie wykona operacj XOR
        ' po uprzednim zdeszyfrowaniu pierwszego bloku danych. Po tej operacji pierwszy
        ' zaszyfrowany blok danych trafi do wybranego (tu "0") sektora RAM, na poczet przyszego
        ' wykorzystania do operacji XOR. Tym sposobem do wykonania zapisu z deszyfrowaniem
        ' w trybie CBC naley tylko raz, przed rozpoczciem deszyfrowania, wgra blok pocztkowy
        ' ("init vector") do wybranego sektora pamici RAM. Numer tego sektora podawany jest
        ' jako argument w rozkazie "deszyfruj i zapisz". Podanie numeru spoza zakresu (0-7)
        ' spowoduje uycie deszyfrowania w trybie ECB (kady blok osobno). }

        ' zapis IV do pamici ulotnej

        Console.Write("Zapis pamieci ul. TeleTokenu:")

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutKey = OutKey + 1                                                     ' zwikszenie licznika kluczy

        OutDataB(TVTTD_CMD) = TVTTC_VMEM_WRITE                                  ' rozkaz zapisu pamici ulotnej TeleTokenu
        OutDataB(TVTTD_PARAM1) = 0                                              ' numer sektora do zapisania

        For n = 0 To 15
            OutDataA(n) = iv(n)                                                 ' wypenienie bufora danymi do zapisania
        Next

        TVTT_CalcAuth(OutDataA, OutDataB)                                                   ' policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T)              ' zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T)              ' zaszyfrowanie drugiego bloku danych
        Status = TVTT_Talk(TokenH, 10, OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC)                ' rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC)                ' rozszyfrowanie drugiego bloku danych


        If (Status <> 0) Then
            Console.Write(vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex(Status And &HFF, 2))
            GoTo Fail
        End If

        If (TVTT_CheckAuth(InDataA, InDataB) <> 0) Then
            Console.Write(vbTab & "Blad bloku kontrolnego!")
            GoTo Fail
        End If

        If (InDataB(TVTTD_STATUS) <> 0) Then
            Console.WriteLine(vbTab & IntToHex(InDataB(TVTTD_STATUS), 2))
            GoTo Fail
        End If

        If (InKey = 0) Then
            Console.WriteLine(vbTab & "Wiamosc nie zaszyfrowana!")                          ' sprawdzenie czy wiamo zaszyfrowana                
            GoTo Fail
        End If

        Console.WriteLine(vbTab & "OK")

        ' zapis pamici nieulotnej TeleTokenu

        Console.Write("Zapis pam. nieul. TeleTokenu:")

        n = 0
        While (n < TokenInfoTbl(TVTTTI_NV_MEM_SIZE))

            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)

            OutKey = OutKey + 1                                                 ' zwikszenie licznika kluczy

            OutDataB(TVTTD_CMD) = TVTTC_NVMEM_DECRYPT_WRITE                     ' rozkaz zapisu pamici Tokenu z uprzednim rozszyfrowaniem bloku danych
            OutDataB(TVTTD_PARAM1) = n                                          ' numer sektora do zapisania
            OutDataB(TVTTD_PARAM2) = 0                                          ' numer hasa do uycia przy deszyfrowaniu
            OutDataB(TVTTD_PARAM3) = 0                                          ' numer sektora pamici ulotnej do uycia przy deszyfrowaniu trybem CBC

            For i = 0 To 15
                OutDataA(i) = data(n * 16 + i)                                  ' wypenienie bufora danymi do zapisania
            Next


            TVTT_CalcAuth(OutDataA, OutDataB)                                                   ' policzenie bloku kontrolnego
            TVTT_CryptBlock(OutDataA, OutKey, SessionKey, TVTT_BLOCK_A, TVTT_PC2T)              ' zaszyfrowanie pierwszego bloku danych
            TVTT_CryptBlock(OutDataB, OutKey, SessionKey, TVTT_BLOCK_B, TVTT_PC2T)              ' zaszyfrowanie drugiego bloku danych
            Status = TVTT_Talk(TokenH, 10, OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
            TVTT_CryptBlock(InDataA, InKey, SessionKey, TVTT_BLOCK_A, TVTT_T2PC)                ' rozszyfrowanie pierwszego bloku danych
            TVTT_CryptBlock(InDataB, InKey, SessionKey, TVTT_BLOCK_B, TVTT_T2PC)                ' rozszyfrowanie drugiego bloku danych


            If (Status <> 0) Then
                Console.Write(vbTab & IntToHex((Status \ 2), 2) & ":" & IntToHex(Status And &HFF, 2))
                Exit While
            End If

            If (TVTT_CheckAuth(InDataA, InDataB) <> 0) Then
                Console.Write(vbTab & "Blad bloku kontrolnego!")
                Exit While
            End If

            If (InDataB(TVTTD_STATUS) <> 0) Then
                Console.WriteLine(vbTab & IntToHex(InDataB(TVTTD_STATUS), 2))
                Exit While
            End If

            If (InKey = 0) Then
                Console.WriteLine(vbTab & "Wiamosc nie zaszyfrowana!")                          ' sprawdzenie czy wiamo zaszyfrowana                
                Exit While
            End If

            n = n + 1
        End While

        If (n = TokenInfoTbl(TVTTTI_NV_MEM_SIZE)) Then Console.WriteLine(vbTab & "OK")

Fail:
        StartEpilog()

    End Sub

End Module
